// ReadThis! applet;
//
// Copyright (C) 1999 by Schachar Levin <pixel.il@usa.net>.  All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
// 1. Redistributions of source code must retain the above copyright
//    notice, this list of conditions and the following disclaimer.
// 2. Redistributions in binary form must reproduce the above copyright
//    notice, this list of conditions and the following disclaimer in the
//    documentation and/or other materials provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
// ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
// FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
// DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
// OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
// LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
// OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
// SUCH DAMAGE.

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import ReadThis.*;

public class RTApplet extends Applet
{
	RT r=new RT();
	
	
	Button encdec=new Button("Encrypt");
	Button clear=new Button("Clear");
	Label cpyright=new Label("Version: 0.1b Copyright (C) 1999 by Schachar Levin http://members.xoom.com/PixIL");
	
	CheckboxGroup cipherType=new CheckboxGroup();
	Checkbox idea=new Checkbox("IDEA",cipherType,true);
	Checkbox xor=new Checkbox("XOR",cipherType,false);
	Checkbox keepFirst=new Checkbox("Keep first line");
	
	TextArea text=new TextArea();
	
	TextField keyID=new TextField();
	TextField textKeyID=new TextField();
	TextField passPhrase=new TextField();
	
	Panel cipherSelect=new Panel(new FlowLayout(FlowLayout.LEFT));
	Panel buttons=new Panel(new FlowLayout(FlowLayout.LEFT));
	Panel textPanel=new Panel(new BorderLayout());
	Panel app=new Panel(new BorderLayout());
	Panel south=new Panel(new GridLayout(2,1));
	public void init()
	{
		//setLayout(new FlowLayout(FlowLayout.LEFT));
		add(app);
		//,BorderLayout.NORTH);
		
		//,BorderLayout.SOUTH);
		//cpyright.setEnabled(false);


		//---------
		app.add(south,BorderLayout.SOUTH);
		south.add(buttons);
		south.add(cpyright);
		buttons.add(encdec);
		encdec.addActionListener(new DoEncDec());
		buttons.add(clear);
		buttons.add(new Label("Passphrase"));
		buttons.add(passPhrase);
		passPhrase.addTextListener(new SetKey());
		passPhrase.setColumns(20);
		passPhrase.setEchoChar('*');
		//---------
		app.add(cipherSelect,BorderLayout.NORTH);
		cipherSelect.add(new Label("Cipher"));
		cipherSelect.add(idea);
		cipherSelect.add(xor);
		cipherSelect.add(new Label("KeyID"));
		keyID.setColumns(9);
		keyID.setEditable(false);
		cipherSelect.add(keyID);
		cipherSelect.add(new Label("Text KeyID"));
		textKeyID.setColumns(9);
		textKeyID.setEditable(false);
		cipherSelect.add(textKeyID);
		
		
		//---------
		app.add(textPanel,BorderLayout.CENTER);
		textPanel.add(new Label("Text"),BorderLayout.NORTH);
		textPanel.add(text,BorderLayout.CENTER);
		textPanel.add(keepFirst,BorderLayout.SOUTH);
		clear.addActionListener(new DoClear());
		//---------
		text.addTextListener(new DoText());
		//---------

		
		
		
	}
	public void setButton()
	{
		if(r.isEncrypted()==false)
		{
			cipherSelect.setEnabled(true);
			if(r.canEncrypt())
				encdec.setEnabled(true);
			else
				encdec.setEnabled(false);
			encdec.setLabel("Encrypt");
		}
		else
		{
			String l;
			encdec.setLabel("Decrypt");
			cipherSelect.setEnabled(false);
			xor.setState(false);
			idea.setState(false);
			if(r.getCipherType().equals("XR"))
			{
				xor.setState(true);
			}
			if(r.getCipherType().equals("ID"))
			{
				idea.setState(true);
			}

			
			
			if(r.canDecrypt())
			{
				encdec.setEnabled(true);
			}
			else
			{
				encdec.setEnabled(false);
			}

		}
	}
	public class SetKey implements TextListener
	{
		public void textValueChanged(TextEvent e)
		{
			String l;
			String pass;
			pass=passPhrase.getText();
			if(pass!=null && !pass.equals(""))
			{
			r.setKey(passPhrase.getText());
			l=Long.toHexString(r.getKeyID());
			if(l.length()>8)
				l=l.substring(8,l.length());
			keyID.setText("0x"+l);
			}
			

			else
			{
				r.setKey();
				keyID.setText("");
			}
			setButton();	
		}
	}
	public class DoText implements TextListener
	{
		public void textValueChanged(TextEvent e)
		{
			String l;
			r.setText(text.getText());
			if(r.canEncrypt()==false) {
				l=Long.toHexString(r.getTextKeyID());
				if(l.length()>8)
					l=l.substring(8,l.length());
				if(r.getTextKeyID()!=0)
				textKeyID.setText("0x"+l);
				
				
			}
			setButton();
		}
	}
	
	public class DoClear implements ActionListener
	{
		public void actionPerformed(ActionEvent e)
		{
			text.setText("");
			setButton();
			textKeyID.setText("");
				
		}
	}
	public class DoEncDec implements ActionListener
	{
		public void actionPerformed(ActionEvent e)
		{
			if(r.canDecrypt())
			{
				
				text.setText(r.decrypt());
				r.setText(text.getText());
			
				setButton();
				return;
			}
			if(r.canEncrypt())
			{
				if(idea.getState())
					r.setCipherType("ID");
				if(xor.getState())
					r.setCipherType("XR");
				text.setText(r.encryptToString());
				r.setText(text.getText());
				setButton();
				return;
			}
		}
	}
}
