// ReadThis! ASCII to binary to ASCII encoding / decoding
//
// Copyright (C) 1999 by Schachar Levin <pixel.il@usa.net>.  All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
// 1. Redistributions of source code must retain the above copyright
//    notice, this list of conditions and the following disclaimer.
// 2. Redistributions in binary form must reproduce the above copyright
//    notice, this list of conditions and the following disclaimer in the
//    documentation and/or other materials provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
// ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
// FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
// DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
// OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
// LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
// OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
// SUCH DAMAGE.
package ReadThis;
public class AscBin
{
	static char base=48;
	static public void setBase(byte new_base)
	{
		byte base=new_base;
	}
	static public long toLong(String encoded_data)
	{
		byte[] b;
		long l;
		b=decode(encoded_data);
		l=(b[0]&0xff)<<24;
		l+=(b[1]&0xff)<<16;
		l+=(b[2]&0xff)<<8;
		l+=b[3]&0xff;
		return l;
	}
	static public String toString(String encoded_data)
	{
	  return new String(decode(encoded_data));
	}
	static public byte[] decode(String encoded_data)
	{
		byte[] output;
		int output_size;
		encoded_data=encoded_data.substring(0,encoded_data.indexOf("qq",0));
		output_size=encoded_data.length()*6/8;
		
		output=new byte[output_size];
		for (int i = 0,pos=0; i < encoded_data.length() && pos<output.length; i++)
		{
			byte t=(byte)(encoded_data.charAt(i)-base);
			switch (i % 4)
			{
			case 0:
				output[pos] =(byte)( t<< 2);
				break;
			case 1:
				output[pos] +=(byte)( (t & 48) >> 4);
				pos++;
				if(pos<output.length)
					output[pos] =(byte)(( t& 15) << 4);
				break;
			case 2:
				output[pos] +=(byte)( (t & 60) >> 2);
				pos++;
				if(pos<output.length)
					output[pos] = (byte)((t & 3) << 6);
				break;
			case 3:
				output[pos] += (byte)t;
				pos++;
				break;
			}
		}
		return output;
	}
	static public String fromString(String s)
	{
		return encode(s.getBytes());
	}
	static public String fromLong(long l)
	{
		byte[] b=new byte[4];
		b[0]=(byte)((l>>24)&0xff);
		b[1]=(byte)((l>>16)&0xff);
		b[2]=(byte)((l>>8)&0xff);
		b[3]=(byte)(l&0xff);
		return encode(b);
	}
		
	static public String encode(byte[] plain_text)
	{
		char[] output;
		int size=plain_text.length;
		size=(int)(size*8/6);
		if((plain_text.length*8%6)>0) size++;
		output=new char[size];
		for (int i = 0, pos = 0; i < plain_text.length; i++)
		{
			switch (i % 3)
			{
			case 0:
				if(pos<size)
				output[pos] =(char) ((base+((plain_text[i] & 252) >> 2))&0xff);
				pos++;
				if(pos<size)
					output[pos] = (char)(base+((plain_text[i] & 3) << 4)&0xff);
				break;
			case 1:
				if(pos<size)
				output[pos] += (char) (((plain_text[i] & 240) >> 4)&0x0ff);
				pos++;
				if(pos<size)
					output[pos] = (char)(base+((plain_text[i] & 15) << 2)&0xff);
				break;
			case 2:
				if(pos<size)
				output[pos] += (char)(((plain_text[i] & 192) >> 6)&0xff);
				pos++;
				if(pos<size)
					output[pos] = (char)(base+(plain_text[i] & 63)&0xff);
				pos++;
				break;
			}
		}
		
		
		return new String((new String(output)+"qq"));
	}
}
